.org 00000H
.assume ADL=0
	out0 (0),a
	jp.lil init
.fill 8-($ % 9)
	jp.lil svchandler
.assume ADL=1
.fill 256-($ % 256)
init:	stmix
	in0 a,(1)
	set 3,a
	out0 (1),a
	ld a,0d4h
	ld (0d5100fh),a
	ld hl,0d4c000h
	ld b,0
colorsetx:
	;ld a,r
	;or a,128
	ld (hl),b
	inc hl
	ld a,r
	or a,128
	;ld (hl),a
	ld (hl),b
	inc hl
	;ld a,r
	;or a,128
	ld (hl),b
	inc hl
	inc b
	jr nz,colorsetx
	ld b,0
	;ld a,'H'
	;ld (0d4c300h),a
	;ld a,255
	;ld (0d4cb00h),a
	ld hl,0d4c300h
	ld (0d50003h),hl
	ld hl,0d4cb00h
	ld (0d50006h),hl
	jp bootdisk
	ld b,255
	ld hl,teststring
	ld c,2
	rst.l 8
	;call.l printstr
	ld b,255
	;jp lplp
	ld b,0
loop4rendx:
	ld hl,0d40000h
	;jp loop4rendx
loop4rend:
	ld a,r
	ld (hl),a
	inc hl
	ld a,h
	cp a,0c0h
	jr nz,loop4rend
	inc b
	;ld b,0
	jr loop4rendx
bootdisk:
	ld a,0d0h
	ld mb,a
	ld a,0
	ld c,3
	rst.l 8
	ld c,4
	rst.l 8

	ld de,08000h
	ld c,6
	rst.l 8

	ld c,7
	rst.l 8
	;jp 0
	call.is 08000h
lplp:
	call.l getchar
	call.l putchar
	jr lplp
teststring:	.db "Hello, World!",00h
	

printstr:
	ld a,(hl)
	and a
	ret.l z
	call.l putchar
	inc hl
	jr printstr

putchar:
	ld (0d50000h),hl
	ld hl,(0d50003h)
	ld (hl),a
	inc hl
	ld (0d50003h),hl
	ld hl,(0d50006h)
	ld (hl),b
	inc hl
	ld (0d50006h),hl
	ld hl,(0d50000h)
	ret.l

putchar_esc:
	ld (0d50000h),hl
	ld (0d50009h),a
	ld a,(0d50004h)
	cp a,0c6h
	jp z,putchar_esc_scroll
putchar_esc_scroll_end:
	ld a,(0d50009h)
;escape sequence
	and a
	jp z,putchar_esc_end

	cp a,7
	jp z,putchar_esc_bel
	cp a,8
	jp z,putchar_esc_bs
	cp a,9
	jp z,putchar_esc_tab
	cp a,0ah
	jp z,putchar_esc_lf

	cp a,0dh
	jp z,putchar_esc_cr

;If a register is up to 31 as special char!
	cp a,020h
	jp c,putchar_esc_end
;putchar_esc_crlf_end:
	ld a,(0d50009h)
	cp a,'['
	jp z,putchar_esc_chartrans_0
	cp a,'$'
	jp z,putchar_esc_chartrans_1
	cp a,0c1h
	jp z,putchar_esc_chartrans_2
	cp a,0f2h
	jp z,putchar_esc_chartrans_3
putchar_esc_chartrans_0_end:
	ld hl,(0d50003h)
	ld (hl),a
	inc hl
	ld (0d50003h),hl
	ld hl,(0d50006h)
	ld (hl),b
	inc hl
	ld (0d50006h),hl
putchar_esc_crlf_end:
putchar_esc_end:
	ld a,(0d50009h)
	ld hl,(0d50000h)
	ret.l
putchar_esc_chartrans_0:
	ld a,0c1h
	jp putchar_esc_chartrans_0_end
putchar_esc_chartrans_1:
	ld a,0f2h
	jp putchar_esc_chartrans_0_end
putchar_esc_chartrans_2:
	ld a,'['
	jp putchar_esc_chartrans_0_end
putchar_esc_chartrans_3:
	ld a,'$'
	jp putchar_esc_chartrans_0_end
putchar_esc_bel:
	jp putchar_esc_end
putchar_esc_bs:
	ld hl,(0d50003h)
	ld a,h
	sub a,0c3h
	or a,l
	cp a,00h
	jp z,putchar_esc_end
	ld a,0
	dec hl
	;ld (hl),a
	ld (0d50003h),hl
	ld hl,(0d50006h)
	dec hl
	;ld (hl),a
	ld (0d50006h),hl
	jp putchar_esc_end
putchar_esc_scroll:
	ld (0d5000ch),bc
	ld (0d5000fh),de
	ld bc,736
	;ld hl,0d4c600h-1
	;ld de,0d4c5e0h-1
	;lddr
	ld hl,0d4c320h
	ld de,0d4c300h
	ldir
	ld bc,736
	;ld hl,0d4ce00h-1
	;ld de,0d4cde0h-1
	;lddr
	ld hl,0d4cb20h
	ld de,0d4cb00h
	ldir
	ld hl,0d4c5e0h
	ld b,32
putchar_esc_scroll_1:
	ld (hl),0
	inc hl
	djnz putchar_esc_scroll_1
	ld hl,0d4cde0h
	ld b,32
putchar_esc_scroll_2:
	ld (hl),0
	inc hl
	djnz putchar_esc_scroll_2
	ld hl,0d4c5e0h
	ld (0d50003h),hl
	ld hl,0d4cde0h
	ld (0d50006h),hl
	ld bc,(0d5000ch)
	ld de,(0d5000fh)
	jp putchar_esc_scroll_end
putchar_esc_lf:
	ld hl,(0d50003h)
	ld a,l
	add a,020h
	ld l,a
	ld a,h
	adc a,0
	ld h,a
	ld (0d50003h),hl
	ld hl,(0d50006h)
	ld a,l
	add a,020h
	ld l,a
	ld a,h
	adc a,0
	ld h,a
	ld (0d50006h),hl
	jp putchar_esc_crlf_end
putchar_esc_cr:
	ld hl,(0d50003h)
	ld a,l
	and a,0E0h
	ld l,a
	ld (0d50003h),hl
	ld hl,(0d50006h)
	ld a,l
	and a,0E0h
	ld l,a
	ld (0d50006h),hl
	jp putchar_esc_crlf_end
putchar_esc_tab:
	ld (0d5000ch),bc
	ld (0d5000fh),de
	ld hl,(0d50003h)
	ld a,l
	and a,01fh-3
	add a,4
	and a,01fh-3
	ld b,a
	ld a,l
	and a,0e0h
	or a,b
	ld l,a
	ld (0d50003h),hl
	ld b,4
putchar_esc_tab_1:
	dec hl
	ld (hl),0
	djnz putchar_esc_tab_1
	ld hl,(0d50006h)
	ld a,l
	and a,01fh-3
	add a,4
	and a,01fh-3
	ld b,a
	ld a,l
	and a,0e0h
	or a,b
	ld l,a
	ld (0d50006h),hl
	ld b,4
putchar_esc_tab_2:
	dec hl
	ld (hl),0
	djnz putchar_esc_tab_2
	ld bc,(0d5000ch)
	ld de,(0d5000fh)
	jp putchar_esc_end

getchar:
	ld (0d50000h),hl
	in0 a,(1)
	bit 0,a
	jr z,getchar
	in0 a,(0)
getchar_:
	in0 l,(1)
	bit 0,l
	jr nz,getchar_
	ld hl,(0d50000h)
	ret.l
svchandler:
	ld (0d50009h),a
	ld a,c
	cp a,0
	jp z,svchandler_0
	cp a,1
	jp z,svchandler_1
	cp a,2
	jp z,svchandler_2
	cp a,3
	jp z,svchandler_3
	cp a,4
	jp z,svchandler_4
	cp a,5
	jp z,svchandler_5
	cp a,6
	jp z,svchandler_6
	cp a,7
	jp z,svchandler_7
	cp a,8
	jp z,svchandler_8
	cp a,9
	jp z,svchandler_9
	cp a,0ah
	jp z,svchandler_a
	cp a,0bh
	jp z,svchandler_b
	cp a,0ch
	jp z,svchandler_c
	cp a,0dh
	jp z,svchandler_d
	cp a,0eh
	jp z,svchandler_e
	cp a,0fh
	jp z,svchandler_f
	cp a,010h
	jp z,svchandler_10
	cp a,011h
	jp z,svchandler_11
	cp a,012h
	jp z,svchandler_12
	cp a,013h
	jp z,svchandler_13
	cp a,014h
	jp z,svchandler_14
	cp a,015h
	jp z,svchandler_15
	cp a,016h
	jp z,svchandler_16
	cp a,017h
	jp z,svchandler_17
	cp a,018h
	jp z,svchandler_18
	cp a,019h
	jp z,svchandler_19
	cp a,01ah
	jp z,svchandler_1a
	cp a,01bh
	jp z,svchandler_1b
	cp a,01ch
	jp z,svchandler_1c
	cp a,01dh
	jp z,svchandler_1d
	cp a,01eh
	jp z,svchandler_1e
	cp a,01fh
	jp z,svchandler_1f
	ld a,(0d50009h)
	ld hl,-1
	ret.l
svchandler_0:
	ld a,(0d50009h)
	jp getchar
svchandler_1:
	ld a,(0d50009h)
	jp putchar
svchandler_2:
	ld a,(0d50009h)
	jp printstr
svchandler_3:
	ld a,(0d50009h)
	ld (0d51000h),a
	ret.l
svchandler_4:
	ld a,(0d50009h)
	ld (0d51001h),a
	ret.l
svchandler_5:
	ld a,(0d50009h)
	ld (0d51002h),a
	ret.l
svchandler_6:
	ld a,(0d50009h)
	ld (0d51003h),de
	ret.l
svchandler_7:
	;ld a,mb
	;ld (0d51002h),a

	ld a,(0d51000h)
	out0 (2),a
	ld a,(0d51001h)
	out0 (2),a
	ld a,(0d51002h)
	out0 (2),a
	ld a,0
	out0 (2),a

	ld a,(0d51003h)
	out0 (3),a
	ld a,(0d51004h)
	out0 (3),a
	;ld a,(0d51005h)
	ld a,mb
	out0 (3),a

	ld a,(0d50009h)
	and a,07fh
	rla
	res 0,a
	out0 (4),a
	in0 a,(1)
	bit 1,a
	jp nz,diskaccfailed
	ld a,00h
	ret.l
svchandler_8:
	;ld a,mb
	;ld (0d51002h),a

	ld a,(0d51000h)
	out0 (2),a
	ld a,(0d51001h)
	out0 (2),a
	ld a,(0d51002h)
	out0 (2),a
	ld a,0
	out0 (2),a

	ld a,(0d51003h)
	out0 (3),a
	ld a,(0d51004h)
	out0 (3),a
	;ld a,(0d51005h)
	ld a,mb
	out0 (3),a

	ld a,(0d50009h)
	and a,07fh
	rla
	set 0,a
	out0 (4),a
	in0 a,(1)
	bit 1,a
	jp nz,diskaccfailed
	ld a,00h
	ret.l
svchandler_9:
	ld hl,0d50003h
	ret.l
svchandler_a:
	in0 a,(1)
	bit 0,a
	jp nz,diskaccfailed
	ld a,00h
	ret.l
svchandler_b:
	ld a,(0d50009h)
	jp putchar_esc
svchandler_c:
	in0 a,(8)
	ret.l
svchandler_d:
	ld a,(0d50009h)
	out (8),a
	ret.l
svchandler_e:
	in0 a,(1)
	bit 4,a
	jp nz,diskaccfailed
	ld a,00h
	ret.l
svchandler_f:
	ret.l
svchandler_10:
	in0 a,(9)
	ret.l
svchandler_11:
	ld a,(0d50009h)
	out (9),a
	ret.l
svchandler_12:
	in0 a,(1)
	bit 5,a
	jp nz,diskaccfailed
	ld a,00h
	ret.l
svchandler_13:
	in0 a,(0ah)
	ret.l
svchandler_14:
	ld a,(0d50009h)
	out (0ah),a
	ret.l
svchandler_15:
	in0 a,(1)
	bit 6,a
	jp nz,diskaccfailed
	ld a,00h
	ret.l
svchandler_16:
	in0 a,(0bh)
	ret.l
svchandler_17:
	ld a,(0d50009h)
	out (0bh),a
	ret.l
svchandler_18:
	in0 a,(1)
	bit 7,a
	jp nz,diskaccfailed
	ld a,00h
	ret.l
svchandler_19:
	ld (0d5000ch),bc
	ld (0d5000fh),de
	ld (0d50000h),hl
	;gfill
	ld (0d51006h),de
	ld a,0h
	ld (0d5100ah),a
	ld a,(0d5100fh)
	ld (0d51008h),a
	;filling
	ld hl,(0d51006h)
	ld a,(0d50001h)
	sub a,d
	ld b,a
loop4_gfill_2:
	ld a,b
	ld (0d5100ah),a
	;loadlp1
	ld a,(0d50000h)
	sub a,e
	ld b,a
	ld a,(0d51006h)
	ld l,a
loop4_gfill_1:
	ld a,(0d50009h)
	ld (hl),a
	inc l
	jr z,loop4_gfill_1_bps
	djnz loop4_gfill_1
loop4_gfill_1_bps:
	inc h
	;loadlp2
	ld a,(0d5100ah)
	ld b,a
	djnz loop4_gfill_2
	;end of the call
	ld hl,(0d50000h)
	ld de,(0d5000fh)
	ld bc,(0d5000ch)
	ld a,(0d50009h)
	ret.l
svchandler_1a:
	ld (0d5000ch),bc
	ld (0d5000fh),de
	ld (0d50000h),hl
	ld (0d50012h),ix
	;gfill
	ld (0d51006h),de
	ld a,0h
	ld (0d5100ah),a
	ld a,(0d5100fh)
	ld (0d51008h),a
	ld (0d5100ch),ix
	ld a,(0d5100fh)
	ld (0d5100eh),a
	;filling
	ld ix,(0d5100ch)
	ld hl,(0d51006h)
	ld a,(0d50001h)
	;sub a,d
	ld b,a
loop4_gcpy_2:
	ld a,b
	ld (0d5100ah),a
	;loadlowptx
	ld a,(0d50012h)
	ld ixl,a
	;loadlp1
	ld a,(0d50000h)
	;sub a,e
	ld b,a
	ld a,(0d51006h)
	ld l,a
loop4_gcpy_1:
	ld a,(ix)
	ld (hl),a
	inc l
	jr z,loop4_gcpy_1_bps
	inc ixl
	jr z,loop4_gcpy_1_bps
	djnz loop4_gcpy_1
loop4_gcpy_1_bps:
	inc h
	inc ixh
	;loadlp2
	ld a,(0d5100ah)
	ld b,a
	djnz loop4_gcpy_2
	;end of the call
	ld ix,(0d50012h)
	ld hl,(0d50000h)
	ld de,(0d5000fh)
	ld bc,(0d5000ch)
	ld a,(0d50009h)
	ret.l
svchandler_1b:
	ld a,(0d50009h)
	ld (0d5100fh),a
	ret.l
svchandler_1c:
	ld (0d5000ch),bc
	ld (0d5000fh),de
	ld (0d50000h),hl
	
	ld (0d51006h),de
	ld a,(0d5100fh)
	ld (0d51008h),a
	ld de,(0d51006h)
	
	ld a,(0d50009h)
	ld (de),a
	
	ld hl,(0d50000h)
	ld de,(0d5000fh)
	ld bc,(0d5000ch)
	ld a,(0d50009h)
	ret.l
svchandler_1d:
	ld (0d5000ch),bc
	ld (0d5000fh),de
	ld (0d50000h),hl
	
	ld (0d51006h),de
	ld a,(0d5100fh)
	ld (0d51008h),a
	ld de,(0d51006h)
	
	ld a,(de)
	
	ld hl,(0d50000h)
	ld de,(0d5000fh)
	ld bc,(0d5000ch)
	ret.l
svchandler_1e:
	ld a,(0d50009h)
	ret.l
svchandler_1f:
	ld a,(0d50009h)
	ret.l

diskaccfailed:
	ld a,0ffh
	ret.l